<template>
  <div class="q-ma-xl text-h4">
    <span v-if="selectedRow.id">Update user</span>
    <span v-else>Add user</span>
    <q-card>
      <q-card-section>
        <q-form
          class="q-pa-xl"
          ref="forms"
          @submit="!selectedRow.id ? addUser() : updateUser()"
        >
          <div class="row">
            <div class="col q-ma-sm">
              <q-input
                round
                outlined
                label="name"
                v-model="form.name"
                lazy-rules
                :rules="[(val) => !!val || 'Field is required']"
              />
            </div>
            <div class="col q-ma-sm">
              <q-input
                round
                outlined
                label="nickname"
                v-model="form.nickname"
                :rules="[(val) => !!val || 'Field is required']"
              />
            </div>
          </div>
          <div class="row">
            <div class="col q-ma-sm">
              <q-input
                round
                outlined
                label="email"
                v-model="form.email"
                :rules="[(val) => !!val || 'Field is required']"
              />
            </div>
            <div class="col q-ma-sm">
              <q-input
                round
                outlined
                label="contact"
                v-model="form.contact"
                :rules="[(val) => !!val || 'Field is required']"
              />
            </div>
            <div class="col q-ma-sm">
              <q-input
                round
                outlined
                label="quote"
                v-model="form.quote"
                :rules="[(val) => !!val || 'Field is required']"
              />
            </div>
          </div>
          <q-btn
            class="bg-primary float-right"
            :label="!selectedRow.id ? 'Add' : 'Update'"
            type="submit"
            :loading="btnLoadingState"
          />
        </q-form>
      </q-card-section>
    </q-card>
    <q-dialog v-model="showDialog" persistent>
      <q-card class="bg-secondary">
        <q-card-section
          style="
            width: 300px;
            height: 150px;
            display: flex;
            justify-content: center;
            align-items: center;
          "
        >
          <div
            style="display: flex; justify-content: center; align-items: center"
          >
            <span class="text-grey-11">{{ successMes }}</span>
          </div>
        </q-card-section>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import axios from "axios";
import { defineComponent, ref } from "vue";
import { rows, form, selectedRow } from "../composables/users";
import { useRouter } from "vue-router";

export default defineComponent({
  name: "add-user",

  setup() {
    let btnLoadingState = ref(false);
    let forms = ref(null);
    const router = useRouter();
    let showDialog = ref(false);
    let successMes = ref(null);

    const addUser = async () => {
      let status = ref("added");
      btnLoadingState.value = true;
      try {
        await new Promise((resolve) => {
          setTimeout(() => {
            axios
              .post("http://localhost:3000/users", form.value)
              .then((response) => {
                rows.value.unshift(response.data);
                form.value = {};
                forms.value.reset();
                successMes.value = `Data ${status.value} successfully`;
              });
            resolve();
          }, 1000);
        });
      } catch (error) {
        console.error(error);
      }

      btnLoadingState.value = false;
      showDialog.value = true;
      setTimeout(() => {
        router.push({ name: "list-user" });
      }, 2000);
    };
    const updateUser = async () => {
      let status = ref("updated");
      btnLoadingState.value = true;
      try {
        await new Promise((resolve) => {
          setTimeout(() => {
            axios
              .put(
                `http://localhost:3000/users/${selectedRow.value.id}`,
                form.value
              )
              .then((response) => {
                if (response.status === 200) {
                  for (let i = 0; i < rows.value.length; i++) {
                    if (rows.value[i].id === selectedRow.value.id) {
                      rows.value[i] = response.data;
                    }
                    form.value = {};
                    selectedRow.value = {};
                    forms.value.reset();
                    successMes.value = `Data ${status.value} successfully`;
                  }
                }
              });

            resolve();
          }, 1000);
        });
      } catch (error) {
        console.error(error);
      }

      btnLoadingState.value = false;
      showDialog.value = true;
      setTimeout(() => {
        router.push({ name: "list-user" });
      }, 2000);
    };

    return {
      form,
      rows,
      addUser,
      btnLoadingState,
      forms,
      selectedRow,
      updateUser,
      showDialog,
      successMes,
    };
  },
});
</script>
